#ifndef DEVICEPROXY_H
#define DEVICEPROXY_H

#include <QObject>

class DeviceProxy : public QObject
{
		Q_OBJECT

	public:
		DeviceProxy();

		Q_INVOKABLE virtual bool initiate(QString port, int param = 0) = 0;
		virtual bool isOpen() const = 0;
		virtual bool isInitiated() const = 0;

		virtual void close() = 0;
		virtual int write(const QByteArray& data) = 0;
		virtual QByteArray readAll() = 0;
		virtual QString errorString() const = 0;
		virtual bool waitForReadyRead(int msec = 30000) = 0;
		virtual QString portName() const = 0;
		virtual QString stateString() const = 0;

	signals:
		void portOpened();
		void portClosed();
		void infoMessage(QString);
		void errorOccurred(QString);
		void readyRead();
};

#endif // DEVICEPROXY_H
