#ifndef UDPDEVICE_H
#define UDPDEVICE_H

#include "DeviceProxy.h"
#include <QAbstractSocket>

class Client;
class QUdpSocket;

class UdpDevice : public DeviceProxy
{
		Q_OBJECT
	public:
		UdpDevice();
		UdpDevice(QString port, int param = 0);
		~UdpDevice();

		int write(const QByteArray& data) Q_DECL_OVERRIDE;
		bool initiate(QString port, int param = 0) Q_DECL_OVERRIDE;
		bool isOpen() const Q_DECL_OVERRIDE;
		bool isInitiated() const Q_DECL_OVERRIDE;
		void close() Q_DECL_OVERRIDE;
		QByteArray readAll() Q_DECL_OVERRIDE;
		QString errorString() const Q_DECL_OVERRIDE;
		bool waitForReadyRead(int msec) Q_DECL_OVERRIDE;
		QString portName() const Q_DECL_OVERRIDE;
		QString stateString() const Q_DECL_OVERRIDE;

		bool isServerMode() const;

	private:
		QScopedPointer<QUdpSocket> socket;
		Client* client;
};

#endif // UDPDEVICE_H
